﻿###########################################################
#
#          Binární vyhledávání
#
# Program najde index zadanou hodnotu "co" v poli "kde"
#
# Vlastní hledání provádí funkce BinárníVyhledáváníImpl(),
# která dostane na počátku navíc parametry určující rozmezí 
# indexů, v němž je třeba hledat
###########################################################

import sys

def binární_vyhledávání_impl(co, kde, od: int, po: int)->int:
    """Pomocná funkce pro hledání hodnoty "co" v rozmezí indexů
       počínade "od" až "po" včetně v poli "kde"""
    if od == po:
        if kde[od] == co:
            return od
        else:
            return -1
    if (co < kde[od]) or (co > kde[po]):
        return -1
    m = (od + po)//2
    if co <= kde[m]:
        return binární_vyhledávání_impl(co, kde, od, m)
    else:
        return binární_vyhledávání_impl(co, kde, m + 1, po)

def binární_vyhledávání(co, kde) -> int:
    return binární_vyhledávání_impl(co, kde, 0, len(kde) - 1)



def main()->int:
    co = 32                                                   # Hledaná hodnota
    data = [1, 3, 5, 6, 7, 9, 10, 15, 17, 18, 21, 22, 32, 52] # Prohledávané pole

    i: int = binární_vyhledávání(co, data)
    if i >= 0: print(f"Hledaná hodnota {data[i]} má index {i}")
    else: print(f"Hodnota {co} tam není")
    return 0

if __name__ == '__main__':
    sys.exit(main())