﻿###########################################################
#
# Výpočet určitého integrálu metodou Monte Carlo
#
###########################################################


from math import exp, sqrt, e
import random
import sys

def f(x: float)->float:
    return x*x


###########################################################
# Výpočet integrálu z funkce exp(x) od 0 do 1 metodou Monte 
# Carlo; μ je odhad střední hodnoty jisté náhdné veličiny 
# (tato střední hodnota je rovna počítanému integrálu) 
# a σ je směrodatná odchylka
def integrál(fce, n):
    r, t = 0, 0
    for i in range(0, n+1):
        x = fce(random.random())
        r += x
        t += x*x
    μ = r/n
    σ = sqrt((t - μ*r)/(n-1)/n)
    return μ, σ


def main() -> int:
    μ, σ = integrál(exp, 10000)
    print("Integrál z funkce exp() od 0 do 1 je " + str(μ) + " ± " + str(σ))
    print(f"Přesná hodnota je {e - 1}")
    return 0

if __name__ == '__main__':
    sys.exit(main())