﻿###########################################################
#
# Program vypisuje řešení úlohy N dam pro různá N 
# od 4 do 20 (nejvýše však HRANICE_VÝPISU řešení)
# a celkový počet řešení této úlohy.
# Počet dam zadává uživatel z příkazové řádky.
# Po zadání záporného čísla program skončí.
#
###########################################################

from os import system
from sys import exit

global Řešení, početDam, početŘešení, maxdam, HRANICE_VÝPISU

početŘešení, početDam = 0, 0
MAX_DAM = 20                       # Maximální počet dam
HRANICE_VÝPISU = 8                 # Maximální počet vypsaných řešení
Řešení: list = [0]*MAX_DAM         
 

def výpis():
	"""Vypíše nalezené řešení"""
	print("(", end="")
	for i in range(0, početDam - 1):
		print(Řešení[i], end=", ")
	print(Řešení[početDam-1], end=")\n")

def Bezpečná(řádka, sloupec)->bool: 
	"""Testuje, zda je daná pozice na šachovnici bezpečná pro další dámu  (k: řádka, m: sloupec)"""
	b = True
	if sloupec > 0:
		l = 0
		while b and (l < sloupec):
			b = (Řešení[l] != řádka) and ((Řešení[l] + l) != (sloupec + řádka)) and ((Řešení[l]-l) != (řádka-sloupec))
			if not b: break
			l += 1
	return b

def vyřeš(sloupec):
	"""Řeší úlohu N dam backtrackingem (počínaje daným sloupcem) 
	   a vypisuje nalezená řešení"""
	global početŘešení
	if sloupec == početDam:
		početŘešení += 1
		if početŘešení <= HRANICE_VÝPISU:
			výpis()	
	else:
		for k in range(0, početDam):
			if Bezpečná(k, sloupec):
				Řešení[sloupec] = k
				vyřeš(sloupec+1)
		Řešení[sloupec] = 0

def main()->int:
	global početDam, početŘešení
	while True:
		print("Zadej počet dam (číslo <=0 znamená konec): ", end = "")
		početDam = int(input())
		if početDam <= 0: break
		if početDam > MAX_DAM:
			print("Počet dam nesmí přesáhnout %d" % MAX_DAM)
			system("PAUSE")
			continue
		početŘešení = 0
		vyřeš(0)
		print("Úloha %d dam má %d řešení" % (početDam, početŘešení))
		system("PAUSE")
	return 0

if __name__ == '__main__':
    exit(main())




