﻿######################################################
#
#              Ackermannova funkce
#               
# Funkce Ack1() počítá funkční hodnoty, počet volání 
# a maximální hloubku rekurze 
# Program si vyžádá od uživatele hodnoty parametrů
# Zadání záporné hodnoty nebo jen jednoho čísla
# ukončí program 
######################################################
import sys

global počet, maximální_hloubka, hloubka, max_n 
počet, maximální_hloubka, hloubka, max_n = 0,0,0,0

def ackermann(m: int, n: int)->int:
     """Implementace Ackermannovy funkce dle definice"""
     if m == 0: return n+1
     if n == 0: return ackermann(m - 1, 1)
     return ackermann(m-1, ackermann(m, n-1))

def ackermann1(m: int, n: int)->int:
    """Implementace Ackermannovy funkce upravené
       pro sledování hloubky rekurze a počtu volání"""
    global počet, maximální_hloubka, hloubka, max_n
    počet += 1
    hloubka += 1
    if hloubka > maximální_hloubka:
        maximální_hloubka = hloubka
    if n > max_n:
        max_n = n
    #zde začíná vlastní výpočet
    if m == 0: 
        výsledek = n+1
    elif n == 0:
        výsledek = ackermann1(m - 1, 1)
    else:
        výsledek = ackermann1(m-1, ackermann1(m, n-1))
    hloubka -= 1
    return výsledek

def main()->int:
    global počet, maximální_hloubka, hloubka, max_n
    while True:
        try:
            print("Zadej parametry: ", end = "")
            m,n = map(int,sys.stdin.readline().split())
            if (m < 0) or (n < 0) : break
            počet, hloubka, max_n, maximální_hloubka = 0, 0, 0, 0
            výsledek = ackermann1(m, n)
            print(f"{výsledek = }")
            print(f"počet volání: {počet}")
            print(f"hloubka rekurze: {maximální_hloubka}\n-------------")
        except ValueError: break
    print("Končíme")
    return 0

if __name__ == '__main__':
    sys.exit(main())


