﻿#######################################################
#
#                    Ackermannova funkce
#                     
# Nerekurzivní implementace pomocí zásobníku
# Program si vyžádá od uživatele hodnoty parametrů
# Zadání záporné hodnoty nebo jen jednoho čísla
# ukončí program 
######################################################
import sys

def ackermann(m: int, n: int)->int:
    """Nerekuzivní implementace Ackermannovy funkce pomocí zásobníku"""
    Zásobník = [0]*10000
    Zásobník[slice(0, 1)] = m, n          # Vyplní první dva prvky zásobníku
    k: int = 1
    while k > 0:
        if Zásobník[k - 1] == 0:
            Zásobník[k-1] = Zásobník[k] + 1
            k -= 1  
        elif Zásobník[k] == 0:
            Zásobník[k-1] = Zásobník[k - 1] - 1
            Zásobník[k] = 1
        else:
            Zásobník[k + 1] = Zásobník[k] - 1
            Zásobník[k] = Zásobník[k-1]
            Zásobník[k-1] = Zásobník[k - 1] - 1
            k += 1
    return Zásobník[0]

def main()->int:
    while True:
        try:
            print("Zadej parametry: ", end = "")
            m,n = map(int,sys.stdin.readline().split())
            if (m < 0) or (n < 0) : break
            výsledek = ackermann(m, n)
            print(f"{výsledek = }", )
            print("-----------")
        except ValueError: break
    print("Končíme")
    return 0

if __name__ == '__main__':
    sys.exit(main())