﻿###########################################################
#
#                       Třídění haldou 
###########################################################

import sys

# Pomocná funkce
# Zařadí prvek, který leží před začátkem úseku tvořícího
# haldu, do této haldy
def _vlož_do_haldy(A: list, levý: int, pravý: int):
	"""Zařadí prvek, který leží před začátkem úseku tvořícího
       haldu, do této haldy"""
	i: int = levý
	j: int = 2*i + 1
	x = A[i]                  #Přidávaný prvek
	while j <= pravý:         #V tomto cyklu se x zařadí
		if j < pravý:         # Je třeba porovnat x s větším z následovníků
			if A[j] < A[j+1]: j += 1
		if x >= A[j]: break   #x je větší - konec
		A[i] = A[j]
		i = j
		j = 2*i + 1
	A[i] = x

#Vlastní třídění
def třídění_haldou(A: list):
	"""Setřídí zadané pole tříděním haldou"""
	n = len(A)
	levý = (n // 2) + 1         #Prvky s indexy levý..pravý
	pravý = n - 1               #již tvoří haldu
	while levý > 0:             #Vytvoření prvotní haldy
		levý -= 1
		_vlož_do_haldy(A, levý, pravý)
	while pravý > 0:            #Nalezené největší prvky dávej na konec pole
		x = A[levý]
		A[levý] = A[pravý]
		A[pravý] = x
		pravý -= 1
		_vlož_do_haldy(A, 0, pravý)

def main()->int:
	a = [5,2,4,6,8,1,7,3,0,10,15,9,11,14,13,12,20,19,18,17,16]
	třídění_haldou(a)
	print(a)

if __name__ == '__main__':
    sys.exit(main())