﻿import sys

def je_seřazené(A: list)->bool:
    n = len(A)
    for i in range(0, n-1):
        if A[i] > A[i+1]: return False
    return True

def další_permutace(a: list)->list:
    """Vytvoří lexikograficky následující permutaci.
    Když taková neexistuje, převrátí pole.
    """
    # Najdeme největší index i, pro který platí a[i] < a[i + 1]. 
    # Pokud takový index neexistuje, vrátí se na začátek tak, 
    # že pole převrátí.
    for i in reversed(range(len(a) - 1)):
        if a[i] < a[i + 1]:
            break  
    else:  # Index nenalezen, převrátíme pole a vrátíme ho
        #a = a[::-1]
        a[0:] = reversed(a[0:])
        return a  

    # Najde největší index j větší než i, pro který platí a[i] < a[j]
    j = next(j for j in reversed(range(i + 1, len(a))) if a[i] < a[j])

    # prohodí hodnoty v a[i] a a[j]
    a[i], a[j] = a[j], a[i]

    # Otočí pole počínaje a[i + 1] po poslední prvek a[n]
    a[i + 1:] = reversed(a[i + 1:])
    return a


def naivní_třídění(A: list)->list:
    while not je_seřazené(A):
        další_permutace(A)
    return A


def main()->int:
    #A = [3,2,1,6,5,4]
    A = [1,2,3,4,5,6]
    A = naivní_třídění(A)
    print(A)

if __name__ == "__main__":
    sys.exit(main())