﻿###########################################################
#
#             Shellovo třídění
#
# s krokem 1, 4, 13, ...
###########################################################
from math import log, pow
import sys

def shellovo_třídění(A: list):
	"""Shellovo třídění s krokem 1, 4, 13, ..."""
	n = len(A)
	počet = max(int(log(n)/log(3) - 1), 1)
	krok = int(pow(3, počet + 1) - 1) // 2
	while krok > 0:
		for i in range(krok, n):
			j = i
			pom = A[i]
			while (j >= krok) and (A[j - krok] > pom):
				A[j] = A[j - krok]
				j -= krok
			A[j] = pom
		krok //= 3

def main()->int:
	a = [5,2,4,6,8,1,7,3,0,10,15,9,11,14,13,12,20,19,18,17,16]
	shellovo_třídění(a)
	print(a)
	return 0

if __name__ == '__main__':
    sys.exit(main())