﻿################################################
#
#    Převod čísla do zadané číselné soustavy
#
# Základ cílové soustavy je celé číslo v rozmezí
# 2 .. 35, výsledkem je znakový řetězec, jenž
# obsahuje zápis daného čísla v této soustavě
# Desetinná čísla vypisuje na POČET_CIFER_ZLOMKU
# míst za řádovou čárkou
################################################

import sys

global POČET_CIFER_ZLOMKU
POČET_CIFER_ZLOMKU = 20


global cifry
cifry = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 
         'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 
         'Y', 'Z']

def převod_celého_čísla(číslo: int, základ: int)->str:
    """Vyjádří zadané celé číslo v soustavě o zadaném základu"""
    if základ < 2 or základ > 35:
        raise ValueError("chybný základ")
    if číslo == 0: return "0"
    záporné = číslo < 0
    if záporné: číslo = -číslo
    výsledek:str = ""
    while číslo > 0:
        výsledek += cifry[číslo % základ]
        číslo = číslo // základ
    return ("-" if záporné else "") + výsledek[::-1] #[::-1] znamená obrácení řetězce

def převod_zlomku(číslo: float, základ: int)->str:
    """Pomocná funkce pro vyjádření zlomkové části v soustavě
       o zadaném základu"""
    výsledek: str = ""
    for i in range(0, POČET_CIFER_ZLOMKU):
        číslo *= základ
        výsledek += cifry[int(číslo)]
        číslo %= 1
    return výsledek

def převod_reálného_čísla(číslo: float, základ: int)->str:
    """Pomocná funkce pro vyjádření zlomkové části v soustavě
       o zadaném základu"""
    záporné = číslo < 0
    if záporné: číslo = -číslo
    celá_část: int = int(číslo)
    zlomek: float = číslo - celá_část
    text = převod_celého_čísla(celá_část, základ) + "," + převod_zlomku(zlomek, základ)
    return ("-" if záporné else "") + text

def main()->int:
    try:
        print(převod_celého_čísla(číslo = 65534, základ = 16))
        print(převod_reálného_čísla(3.14, 2))
    except Exception as e:
        print(e)

if __name__ == '__main__':
    sys.exit(main())